Subject: Re: [PATCH] add GIT_FAST_STAT mode for Cygwin

From: Jakub Narebski <[email-masked]>
Date: Tue, 23 Sep 2008 19:51:19 +0200

Dmitry Potapov wrote:
> On Tue, Sep 23, 2008 at 04:37:14PM +0200, Alex Riesen wrote:
>> 2008/9/23 Dmitry Potapov <[email-masked]>:

>>> +stat_fn_t cygwin_stat_fn = cygwin_stat_choice;
>>> +stat_fn_t cygwin_lstat_fn = cygwin_lstat_choice;
>> ...
>>> +typedef int (*stat_fn_t)(const char*, struct stat*);
>>> +extern stat_fn_t cygwin_stat_fn;
>>> +extern stat_fn_t cygwin_lstat_fn;
>> 
>>     extern int (*cygwin_stat_fn)(const char *, struct stat *);
>> 
>> Is shorter, easier to read and easier to understand (for a C person).
>> You don't even use the type anywhere else, it is just for the declaration sake!
> 
> I use it in description of a parameter of another function:
> 
> static int do_stat(const char *file_name, struct stat *buf, stat_fn_t cygstat)
> 
> Of course, you can avoid it here too, but the declaration will become
> somewhat longer:
> 
> static int do_stat(const char *file_name, struct stat *buf,
>        int (*cygstat)(const char *, struct stat *));
> 
> so I am not sure that removing stat_fn_t improves readability, but if
> there are other people who think so, I will correct that.

I think that using typedef here definitly improves readibility.
You don't have to carefully analyse if you can pass cygwin_stat_fn
to do_stat function or not.

-- 
Jakub Narebski
Warsaw, Poland
ShadeHawk on #git